/* fuzzy-search-popover.c generated by valac 0.56.17, the Vala compiler
 * generated from fuzzy-search-popover.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2023 elementary, Inc. <https://elementary.io>
 *
 * Authored by: Marvin Ahlgrimm
 *              Colin Kiama <colinkiama@gmail.com>
 */

#include "fuzzy-search.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "codecore.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SCRATCH_FUZZY_SEARCH_POPOVER_0_PROPERTY,
	SCRATCH_FUZZY_SEARCH_POPOVER_CURRENT_WINDOW_PROPERTY,
	SCRATCH_FUZZY_SEARCH_POPOVER_SIDEBAR_IS_VISIBLE_PROPERTY,
	SCRATCH_FUZZY_SEARCH_POPOVER_NUM_PROPERTIES
};
static GParamSpec* scratch_fuzzy_search_popover_properties[SCRATCH_FUZZY_SEARCH_POPOVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _scratch_services_fuzzy_finder_unref0(var) ((var == NULL) ? NULL : (var = (scratch_services_fuzzy_finder_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _search_result_unref0(var) ((var == NULL) ? NULL : (var = (search_result_unref (var), NULL)))
enum  {
	SCRATCH_FUZZY_SEARCH_POPOVER_OPEN_FILE_SIGNAL,
	SCRATCH_FUZZY_SEARCH_POPOVER_CLOSE_SEARCH_SIGNAL,
	SCRATCH_FUZZY_SEARCH_POPOVER_NUM_SIGNALS
};
static guint scratch_fuzzy_search_popover_signals[SCRATCH_FUZZY_SEARCH_POPOVER_NUM_SIGNALS] = {0};

struct _ScratchFuzzySearchPopoverPrivate {
	GtkSearchEntry* search_term_entry;
	ScratchServicesFuzzyFinder* fuzzy_finder;
	GtkListBox* search_result_container;
	gint preselected_index;
	GtkScrolledWindow* scrolled;
	GeeArrayList* items;
	ScratchServicesFuzzySearchIndexer* indexer;
	gint window_height;
	gint max_items;
	GeeLinkedList* cancellables;
	GtkEventControllerKey* search_term_entry_key_controller;
	GtkLabel* title_label;
	ScratchMainWindow* _current_window;
	gboolean _sidebar_is_visible;
};

struct _Block10Data {
	int _ref_count_;
	ScratchFuzzySearchPopover* self;
	gchar* previous_text;
};

struct _Block11Data {
	int _ref_count_;
	Block10Data * _data10_;
	GCancellable* next_cancellable;
};

static gint ScratchFuzzySearchPopover_private_offset;
static gpointer scratch_fuzzy_search_popover_parent_class = NULL;
static GType scratch_fuzzy_search_popover_type_id = 0;

static void scratch_fuzzy_search_popover_calculate_scroll_offset (ScratchFuzzySearchPopover* self,
                                                           gint old_position,
                                                           gint new_position);
static void scratch_fuzzy_search_popover_handle_item_selection (ScratchFuzzySearchPopover* self,
                                                         gint index);
static void scratch_fuzzy_search_popover_preselect_new_item (ScratchFuzzySearchPopover* self,
                                                      FileItem* old_item,
                                                      FileItem* new_item);
static gchar* scratch_fuzzy_search_popover_get_current_project (ScratchFuzzySearchPopover* self);
static GObject * scratch_fuzzy_search_popover_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void _scratch_fuzzy_search_popover___lambda19_ (ScratchFuzzySearchPopover* self,
                                                GtkListBoxRow* row);
static void __scratch_fuzzy_search_popover___lambda19__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                            GtkListBoxRow* row,
                                                                            gpointer self);
static gboolean _scratch_fuzzy_search_popover___lambda20_ (ScratchFuzzySearchPopover* self,
                                                    guint keyval,
                                                    guint keycode,
                                                    GdkModifierType state);
static gboolean __scratch_fuzzy_search_popover___lambda20__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                          guint keyval,
                                                                                          guint keycode,
                                                                                          GdkModifierType state,
                                                                                          gpointer self);
static void _scratch_fuzzy_search_popover___lambda21_ (ScratchFuzzySearchPopover* self);
static void __scratch_fuzzy_search_popover___lambda21__gtk_entry_activate (GtkEntry* _sender,
                                                                    gpointer self);
static void _scratch_fuzzy_search_popover___lambda22_ (ScratchFuzzySearchPopover* self,
                                                GtkEditable* e);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ___lambda23_ (Block10Data* _data10_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda24_ (Block11Data* _data11_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda24__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean ____lambda23__gsource_func (gpointer self);
static void __scratch_fuzzy_search_popover___lambda22__gtk_editable_changed (GtkEditable* _sender,
                                                                      gpointer self);
static void scratch_fuzzy_search_popover_finalize (GObject * obj);
static void _vala_scratch_fuzzy_search_popover_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_scratch_fuzzy_search_popover_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
scratch_fuzzy_search_popover_get_instance_private (ScratchFuzzySearchPopover* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchFuzzySearchPopover_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return self ? g_object_ref (self) : NULL;
#line 162 "fuzzy-search-popover.c"
}

ScratchFuzzySearchPopover*
scratch_fuzzy_search_popover_construct (GType object_type,
                                        ScratchServicesFuzzySearchIndexer* search_indexer,
                                        ScratchMainWindow* window)
{
	ScratchFuzzySearchPopover * self = NULL;
	ScratchWidgetsDocumentView* _tmp0_;
	gint height = 0;
	ScratchMainWindow* _tmp1_;
	gint _tmp2_ = 0;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	ScratchServicesFuzzyFinder* _tmp5_;
	ScratchServicesFuzzySearchIndexer* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeLinkedList* _tmp8_;
	GtkScrolledWindow* _tmp9_;
#line 28 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_val_if_fail (search_indexer != NULL, NULL);
#line 28 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 29 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = window->document_view;
#line 29 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self = (ScratchFuzzySearchPopover*) g_object_new (object_type, "modal", TRUE, "relative-to", _tmp0_, "width-request", 500, "current-window", window, NULL);
#line 37 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = self->priv->_current_window;
#line 37 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_window_get_size ((GtkWindow*) _tmp1_, NULL, &_tmp2_);
#line 37 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	height = _tmp2_;
#line 38 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->window_height = height;
#line 40 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = scratch_services_fuzzy_search_indexer_get_project_paths (search_indexer);
#line 40 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp4_ = _tmp3_;
#line 40 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp5_ = scratch_services_fuzzy_finder_new (_tmp4_, 10, 256);
#line 40 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_scratch_services_fuzzy_finder_unref0 (self->priv->fuzzy_finder);
#line 40 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->fuzzy_finder = _tmp5_;
#line 41 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp6_ = _g_object_ref0 (search_indexer);
#line 41 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->indexer);
#line 41 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->indexer = _tmp6_;
#line 42 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp7_ = gee_array_list_new (TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 42 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->items);
#line 42 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->items = _tmp7_;
#line 43 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp8_ = gee_linked_list_new (g_cancellable_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 43 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->cancellables);
#line 43 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->cancellables = _tmp8_;
#line 46 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (self->priv->window_height > 400) {
#line 47 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		self->priv->max_items = 5;
#line 230 "fuzzy-search-popover.c"
	} else {
#line 49 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		self->priv->max_items = 3;
#line 234 "fuzzy-search-popover.c"
	}
#line 52 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp9_ = self->priv->scrolled;
#line 52 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_scrolled_window_set_max_content_height (_tmp9_, 45 * self->priv->max_items);
#line 28 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return self;
#line 242 "fuzzy-search-popover.c"
}

ScratchFuzzySearchPopover*
scratch_fuzzy_search_popover_new (ScratchServicesFuzzySearchIndexer* search_indexer,
                                  ScratchMainWindow* window)
{
#line 28 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return scratch_fuzzy_search_popover_construct (SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, search_indexer, window);
#line 251 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_calculate_scroll_offset (ScratchFuzzySearchPopover* self,
                                                      gint old_position,
                                                      gint new_position)
{
	gboolean _tmp0_ = FALSE;
	gdouble size_box = 0.0;
	GtkScrolledWindow* _tmp14_;
	GtkAdjustment* _tmp15_;
	GtkAdjustment* _tmp16_;
	GeeArrayList* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gdouble current_top = 0.0;
	GtkScrolledWindow* _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkAdjustment* _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble current_bottom = 0.0;
#line 55 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (self != NULL);
#line 57 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (new_position == 0) {
#line 57 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp0_ = old_position > new_position;
#line 280 "fuzzy-search-popover.c"
	} else {
#line 57 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp0_ = FALSE;
#line 284 "fuzzy-search-popover.c"
	}
#line 57 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp0_) {
#line 288 "fuzzy-search-popover.c"
		GtkScrolledWindow* _tmp1_;
		GtkAdjustment* _tmp2_;
		GtkAdjustment* _tmp3_;
#line 58 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp1_ = self->priv->scrolled;
#line 58 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp2_ = gtk_scrolled_window_get_vadjustment (_tmp1_);
#line 58 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp3_ = _tmp2_;
#line 58 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		gtk_adjustment_set_value (_tmp3_, (gdouble) 0);
#line 59 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return;
#line 302 "fuzzy-search-popover.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (old_position == 0) {
#line 307 "fuzzy-search-popover.c"
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp5_ = self->priv->items;
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp7_ = _tmp6_;
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp4_ = new_position == (_tmp7_ - 1);
#line 319 "fuzzy-search-popover.c"
		} else {
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp4_ = FALSE;
#line 323 "fuzzy-search-popover.c"
		}
#line 60 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (_tmp4_) {
#line 327 "fuzzy-search-popover.c"
			GtkScrolledWindow* _tmp8_;
			GtkAdjustment* _tmp9_;
			GtkAdjustment* _tmp10_;
			GtkScrolledWindow* _tmp11_;
			GtkAdjustment* _tmp12_;
			GtkAdjustment* _tmp13_;
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp8_ = self->priv->scrolled;
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp9_ = gtk_scrolled_window_get_vadjustment (_tmp8_);
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp10_ = _tmp9_;
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp11_ = self->priv->scrolled;
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp12_ = gtk_scrolled_window_get_vadjustment (_tmp11_);
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp13_ = _tmp12_;
#line 61 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			gtk_adjustment_set_value (_tmp10_, gtk_adjustment_get_upper (_tmp13_));
#line 62 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			return;
#line 350 "fuzzy-search-popover.c"
		}
	}
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp14_ = self->priv->scrolled;
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp15_ = gtk_scrolled_window_get_vadjustment (_tmp14_);
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp16_ = _tmp15_;
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp17_ = self->priv->items;
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp19_ = _tmp18_;
#line 65 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	size_box = gtk_adjustment_get_upper (_tmp16_) / _tmp19_;
#line 66 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp20_ = self->priv->scrolled;
#line 66 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp21_ = gtk_scrolled_window_get_vadjustment (_tmp20_);
#line 66 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp22_ = _tmp21_;
#line 66 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 66 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp24_ = _tmp23_;
#line 66 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	current_top = _tmp24_;
#line 67 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	current_bottom = current_top + (size_box * (self->priv->max_items - 2));
#line 68 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (old_position < new_position) {
#line 383 "fuzzy-search-popover.c"
		gdouble new_adjust = 0.0;
#line 70 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		new_adjust = size_box * self->priv->preselected_index;
#line 71 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (new_adjust >= current_bottom) {
#line 389 "fuzzy-search-popover.c"
			GtkScrolledWindow* _tmp25_;
			GtkAdjustment* _tmp26_;
			GtkAdjustment* _tmp27_;
#line 72 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp25_ = self->priv->scrolled;
#line 72 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp26_ = gtk_scrolled_window_get_vadjustment (_tmp25_);
#line 72 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp27_ = _tmp26_;
#line 72 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			gtk_adjustment_set_value (_tmp27_, size_box * (self->priv->preselected_index - (self->priv->max_items - 1)));
#line 401 "fuzzy-search-popover.c"
		}
	} else {
#line 74 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (old_position > new_position) {
#line 406 "fuzzy-search-popover.c"
			gdouble new_adjust = 0.0;
#line 76 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			new_adjust = size_box * self->priv->preselected_index;
#line 77 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			if (new_adjust < current_top) {
#line 412 "fuzzy-search-popover.c"
				GtkScrolledWindow* _tmp28_;
				GtkAdjustment* _tmp29_;
				GtkAdjustment* _tmp30_;
#line 78 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp28_ = self->priv->scrolled;
#line 78 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp29_ = gtk_scrolled_window_get_vadjustment (_tmp28_);
#line 78 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp30_ = _tmp29_;
#line 78 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				gtk_adjustment_set_value (_tmp30_, new_adjust);
#line 424 "fuzzy-search-popover.c"
			}
		}
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 448 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_handle_item_selection (ScratchFuzzySearchPopover* self,
                                                    gint index)
{
	FileItem* item = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 265 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (self != NULL);
#line 266 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = self->priv->items;
#line 266 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, index);
#line 266 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	item = (FileItem*) _tmp1_;
#line 267 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = file_item_get_filepath (item);
#line 267 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = _tmp2_;
#line 267 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 267 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp5_ = _tmp4_;
#line 267 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_signal_emit (self, scratch_fuzzy_search_popover_signals[SCRATCH_FUZZY_SEARCH_POPOVER_OPEN_FILE_SIGNAL], 0, _tmp5_);
#line 267 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_free0 (_tmp5_);
#line 265 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (item);
#line 484 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_preselect_new_item (ScratchFuzzySearchPopover* self,
                                                 FileItem* old_item,
                                                 FileItem* new_item)
{
	gchar* class_name = NULL;
	gchar* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 270 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (self != NULL);
#line 270 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (old_item != NULL);
#line 270 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (new_item != NULL);
#line 271 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = g_strdup ("preselect-fuzzy");
#line 271 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	class_name = _tmp0_;
#line 272 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) old_item);
#line 272 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_style_context_remove_class (_tmp1_, class_name);
#line 273 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) new_item);
#line 273 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_style_context_add_class (_tmp2_, class_name);
#line 270 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_free0 (class_name);
#line 516 "fuzzy-search-popover.c"
}

static gchar*
scratch_fuzzy_search_popover_get_current_project (ScratchFuzzySearchPopover* self)
{
	ScratchServicesDocument* current_document = NULL;
	ScratchMainWindow* _tmp0_;
	ScratchWidgetsDocumentView* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* _tmp4_;
	ScratchServicesDocument* _tmp5_;
	ScratchServicesDocument* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gchar* file_path = NULL;
	ScratchServicesDocument* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gchar* _tmp14_;
	GeeIterator* iter = NULL;
	ScratchServicesFuzzySearchIndexer* _tmp15_;
	GeeHashMap* _tmp16_;
	GeeHashMap* _tmp17_;
	GeeSet* _tmp18_;
	GeeSet* _tmp19_;
	GeeSet* _tmp20_;
	GeeIterator* _tmp21_;
	GeeIterator* _tmp22_;
	gchar* _tmp28_;
	gchar* result;
#line 276 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 277 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = self->priv->_current_window;
#line 277 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = _tmp0_->document_view;
#line 277 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = scratch_widgets_document_view_get_current_document (_tmp1_);
#line 277 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = _tmp2_;
#line 277 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 277 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	current_document = _tmp4_;
#line 278 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp5_ = current_document;
#line 278 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp5_ == NULL) {
#line 566 "fuzzy-search-popover.c"
		gchar* _tmp6_;
#line 279 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp6_ = g_strdup ("");
#line 279 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		result = _tmp6_;
#line 279 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (current_document);
#line 279 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return result;
#line 576 "fuzzy-search-popover.c"
	}
#line 282 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp7_ = current_document;
#line 282 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp8_ = scratch_services_document_get_is_file_temporary (_tmp7_);
#line 282 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp9_ = _tmp8_;
#line 282 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp9_) {
#line 586 "fuzzy-search-popover.c"
		gchar* _tmp10_;
#line 283 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp10_ = g_strdup ("");
#line 283 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		result = _tmp10_;
#line 283 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (current_document);
#line 283 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return result;
#line 596 "fuzzy-search-popover.c"
	}
#line 286 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp11_ = current_document;
#line 286 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp12_ = scratch_services_document_get_file (_tmp11_);
#line 286 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp13_ = _tmp12_;
#line 286 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp14_ = g_file_get_path (_tmp13_);
#line 286 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	file_path = _tmp14_;
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp15_ = self->priv->indexer;
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp16_ = scratch_services_fuzzy_search_indexer_get_project_paths (_tmp15_);
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp17_ = _tmp16_;
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp18_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp17_);
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp19_ = _tmp18_;
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp20_ = _tmp19_;
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp22_ = _tmp21_;
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (_tmp20_);
#line 288 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	iter = _tmp22_;
#line 289 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	while (TRUE) {
#line 630 "fuzzy-search-popover.c"
		GeeIterator* _tmp23_;
		gchar* project_path = NULL;
		GeeIterator* _tmp24_;
		gpointer _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 289 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp23_ = iter;
#line 289 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (!gee_iterator_next (_tmp23_)) {
#line 289 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			break;
#line 643 "fuzzy-search-popover.c"
		}
#line 290 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp24_ = iter;
#line 290 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp25_ = gee_iterator_get (_tmp24_);
#line 290 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		project_path = (gchar*) _tmp25_;
#line 291 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp26_ = file_path;
#line 291 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp27_ = project_path;
#line 291 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (g_str_has_prefix (_tmp26_, _tmp27_)) {
#line 292 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			result = project_path;
#line 292 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_g_object_unref0 (iter);
#line 292 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_g_free0 (file_path);
#line 292 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_g_object_unref0 (current_document);
#line 292 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			return result;
#line 667 "fuzzy-search-popover.c"
		}
#line 289 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_free0 (project_path);
#line 671 "fuzzy-search-popover.c"
	}
#line 296 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp28_ = g_strdup ("");
#line 296 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	result = _tmp28_;
#line 296 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (iter);
#line 296 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_free0 (file_path);
#line 296 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (current_document);
#line 296 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 685 "fuzzy-search-popover.c"
}

ScratchMainWindow*
scratch_fuzzy_search_popover_get_current_window (ScratchFuzzySearchPopover* self)
{
	ScratchMainWindow* result;
	ScratchMainWindow* _tmp0_;
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = self->priv->_current_window;
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	result = _tmp0_;
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 701 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_set_current_window (ScratchFuzzySearchPopover* self,
                                                 ScratchMainWindow* value)
{
	ScratchMainWindow* old_value;
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (self != NULL);
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	old_value = scratch_fuzzy_search_popover_get_current_window (self);
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (old_value != value) {
#line 715 "fuzzy-search-popover.c"
		ScratchMainWindow* _tmp0_;
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (self->priv->_current_window);
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		self->priv->_current_window = _tmp0_;
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_fuzzy_search_popover_properties[SCRATCH_FUZZY_SEARCH_POPOVER_CURRENT_WINDOW_PROPERTY]);
#line 725 "fuzzy-search-popover.c"
	}
}

gboolean
scratch_fuzzy_search_popover_get_sidebar_is_visible (ScratchFuzzySearchPopover* self)
{
	gboolean result;
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	result = self->priv->_sidebar_is_visible;
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 739 "fuzzy-search-popover.c"
}

void
scratch_fuzzy_search_popover_set_sidebar_is_visible (ScratchFuzzySearchPopover* self,
                                                     gboolean value)
{
	gboolean old_value;
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (self != NULL);
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	old_value = scratch_fuzzy_search_popover_get_sidebar_is_visible (self);
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (old_value != value) {
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		self->priv->_sidebar_is_visible = value;
#line 23 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_fuzzy_search_popover_properties[SCRATCH_FUZZY_SEARCH_POPOVER_SIDEBAR_IS_VISIBLE_PROPERTY]);
#line 757 "fuzzy-search-popover.c"
	}
}

static void
_scratch_fuzzy_search_popover___lambda19_ (ScratchFuzzySearchPopover* self,
                                           GtkListBoxRow* row)
{
	FileItem* file_item = NULL;
	FileItem* _tmp0_;
	FileItem* _tmp1_;
	GeeArrayList* _tmp2_;
	FileItem* _tmp3_;
#line 103 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (row != NULL);
#line 104 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = _g_object_ref0 (IS_FILE_ITEM (row) ? ((FileItem*) row) : NULL);
#line 104 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	file_item = _tmp0_;
#line 105 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = file_item;
#line 105 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp1_ == NULL) {
#line 106 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (file_item);
#line 106 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return;
#line 784 "fuzzy-search-popover.c"
	}
#line 109 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = self->priv->items;
#line 109 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = file_item;
#line 109 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	scratch_fuzzy_search_popover_handle_item_selection (self, gee_abstract_list_index_of ((GeeAbstractList*) _tmp2_, _tmp3_));
#line 103 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (file_item);
#line 794 "fuzzy-search-popover.c"
}

static void
__scratch_fuzzy_search_popover___lambda19__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                       GtkListBoxRow* row,
                                                                       gpointer self)
{
#line 103 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_scratch_fuzzy_search_popover___lambda19_ ((ScratchFuzzySearchPopover*) self, row);
#line 804 "fuzzy-search-popover.c"
}

static gboolean
_scratch_fuzzy_search_popover___lambda20_ (ScratchFuzzySearchPopover* self,
                                           guint keyval,
                                           guint keycode,
                                           GdkModifierType state)
{
	gboolean result;
#line 115 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	switch (keyval) {
#line 115 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case GDK_KEY_Down:
#line 818 "fuzzy-search-popover.c"
		{
			GeeArrayList* _tmp0_;
			gint _tmp1_;
			gint _tmp2_;
#line 117 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp0_ = self->priv->items;
#line 117 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 117 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp2_ = _tmp1_;
#line 117 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			if (_tmp2_ > 0) {
#line 831 "fuzzy-search-popover.c"
				gint old_index = 0;
				FileItem* item = NULL;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gpointer _tmp5_;
				GeeArrayList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				FileItem* next_item = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				FileItem* _tmp11_;
				FileItem* _tmp12_;
#line 118 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				old_index = self->priv->preselected_index;
#line 119 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp3_ = self->priv->items;
#line 119 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp4_ = self->priv->preselected_index;
#line 119 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				self->priv->preselected_index = _tmp4_ + 1;
#line 119 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, _tmp4_);
#line 119 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				item = (FileItem*) _tmp5_;
#line 120 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp6_ = self->priv->items;
#line 120 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 120 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp8_ = _tmp7_;
#line 120 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				if (self->priv->preselected_index >= _tmp8_) {
#line 121 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					self->priv->preselected_index = 0;
#line 867 "fuzzy-search-popover.c"
				}
#line 124 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp9_ = self->priv->items;
#line 124 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, self->priv->preselected_index);
#line 124 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				next_item = (FileItem*) _tmp10_;
#line 125 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp11_ = item;
#line 125 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp12_ = next_item;
#line 125 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				scratch_fuzzy_search_popover_preselect_new_item (self, _tmp11_, _tmp12_);
#line 126 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				scratch_fuzzy_search_popover_calculate_scroll_offset (self, old_index, self->priv->preselected_index);
#line 117 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_g_object_unref0 (next_item);
#line 117 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_g_object_unref0 (item);
#line 887 "fuzzy-search-popover.c"
			}
#line 129 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			result = TRUE;
#line 129 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			return result;
#line 893 "fuzzy-search-popover.c"
		}
#line 115 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case GDK_KEY_Up:
#line 897 "fuzzy-search-popover.c"
		{
			GeeArrayList* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 131 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp13_ = self->priv->items;
#line 131 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 131 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp15_ = _tmp14_;
#line 131 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			if (_tmp15_ > 0) {
#line 910 "fuzzy-search-popover.c"
				gint old_index = 0;
				FileItem* item = NULL;
				GeeArrayList* _tmp16_;
				gint _tmp17_;
				gpointer _tmp18_;
				FileItem* next_item = NULL;
				GeeArrayList* _tmp22_;
				gpointer _tmp23_;
				FileItem* _tmp24_;
				FileItem* _tmp25_;
#line 132 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				old_index = self->priv->preselected_index;
#line 133 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp16_ = self->priv->items;
#line 133 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp17_ = self->priv->preselected_index;
#line 133 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				self->priv->preselected_index = _tmp17_ - 1;
#line 133 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _tmp17_);
#line 133 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				item = (FileItem*) _tmp18_;
#line 134 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				if (self->priv->preselected_index < 0) {
#line 935 "fuzzy-search-popover.c"
					GeeArrayList* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
#line 135 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					_tmp19_ = self->priv->items;
#line 135 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 135 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					_tmp21_ = _tmp20_;
#line 135 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					self->priv->preselected_index = _tmp21_ - 1;
#line 947 "fuzzy-search-popover.c"
				}
#line 138 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp22_ = self->priv->items;
#line 138 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, self->priv->preselected_index);
#line 138 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				next_item = (FileItem*) _tmp23_;
#line 139 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp24_ = item;
#line 139 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp25_ = next_item;
#line 139 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				scratch_fuzzy_search_popover_preselect_new_item (self, _tmp24_, _tmp25_);
#line 140 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				scratch_fuzzy_search_popover_calculate_scroll_offset (self, old_index, self->priv->preselected_index);
#line 131 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_g_object_unref0 (next_item);
#line 131 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_g_object_unref0 (item);
#line 967 "fuzzy-search-popover.c"
			}
#line 142 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			result = TRUE;
#line 142 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			return result;
#line 973 "fuzzy-search-popover.c"
		}
#line 115 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case GDK_KEY_Escape:
#line 977 "fuzzy-search-popover.c"
		{
#line 145 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			g_signal_emit (self, scratch_fuzzy_search_popover_signals[SCRATCH_FUZZY_SEARCH_POPOVER_CLOSE_SEARCH_SIGNAL], 0);
#line 146 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			result = TRUE;
#line 146 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			return result;
#line 985 "fuzzy-search-popover.c"
		}
		default:
		{
#line 148 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			break;
#line 991 "fuzzy-search-popover.c"
		}
	}
#line 151 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	result = FALSE;
#line 151 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 998 "fuzzy-search-popover.c"
}

static gboolean
__scratch_fuzzy_search_popover___lambda20__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                 guint keyval,
                                                                                 guint keycode,
                                                                                 GdkModifierType state,
                                                                                 gpointer self)
{
	gboolean result;
	result = _scratch_fuzzy_search_popover___lambda20_ ((ScratchFuzzySearchPopover*) self, keyval, keycode, state);
#line 113 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 1012 "fuzzy-search-popover.c"
}

static void
_scratch_fuzzy_search_popover___lambda21_ (ScratchFuzzySearchPopover* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 155 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = self->priv->items;
#line 155 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 155 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = _tmp1_;
#line 155 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp2_ > 0) {
#line 156 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		scratch_fuzzy_search_popover_handle_item_selection (self, self->priv->preselected_index);
#line 1031 "fuzzy-search-popover.c"
	}
}

static void
__scratch_fuzzy_search_popover___lambda21__gtk_entry_activate (GtkEntry* _sender,
                                                               gpointer self)
{
#line 154 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_scratch_fuzzy_search_popover___lambda21_ ((ScratchFuzzySearchPopover*) self);
#line 1041 "fuzzy-search-popover.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return _data10_;
#line 1051 "fuzzy-search-popover.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1061 "fuzzy-search-popover.c"
		ScratchFuzzySearchPopover* self;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		self = _data10_->self;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_free0 (_data10_->previous_text);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (self);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_slice_free (Block10Data, _data10_);
#line 1071 "fuzzy-search-popover.c"
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return _data11_;
#line 1082 "fuzzy-search-popover.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 1092 "fuzzy-search-popover.c"
		ScratchFuzzySearchPopover* self;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		self = _data11_->_data10_->self;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (_data11_->next_cancellable);
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		block10_data_unref (_data11_->_data10_);
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data11_->_data10_ = NULL;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_slice_free (Block11Data, _data11_);
#line 1104 "fuzzy-search-popover.c"
	}
}

static void
__lambda24_ (Block11Data* _data11_,
             GObject* obj,
             GAsyncResult* res)
{
	Block10Data* _data10_;
	ScratchFuzzySearchPopover* self;
	GCancellable* _tmp0_;
	GeeArrayList* results = NULL;
	ScratchServicesFuzzyFinder* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	gboolean first = FALSE;
	GtkListBox* _tmp6_;
	GList* _tmp7_;
	GeeArrayList* _tmp10_;
	GtkScrolledWindow* _tmp33_;
	GtkScrolledWindow* _tmp34_;
	GtkScrolledWindow* _tmp35_;
	GtkAdjustment* _tmp36_;
	GtkAdjustment* _tmp37_;
#line 188 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_data10_ = _data11_->_data10_;
#line 188 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self = _data10_->self;
#line 188 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (res != NULL);
#line 189 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = _data11_->next_cancellable;
#line 189 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 1139 "fuzzy-search-popover.c"
		GeeLinkedList* _tmp1_;
		GCancellable* _tmp2_;
#line 190 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp1_ = self->priv->cancellables;
#line 190 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp2_ = _data11_->next_cancellable;
#line 190 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _tmp2_);
#line 191 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return;
#line 1150 "fuzzy-search-popover.c"
	}
#line 194 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = self->priv->fuzzy_finder;
#line 194 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp4_ = scratch_services_fuzzy_finder_fuzzy_find_finish (_tmp3_, res);
#line 194 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	results = _tmp4_;
#line 195 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp5_ = results;
#line 195 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp5_ == NULL) {
#line 196 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_g_object_unref0 (results);
#line 196 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return;
#line 1166 "fuzzy-search-popover.c"
	}
#line 199 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	first = TRUE;
#line 203 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp6_ = self->priv->search_result_container;
#line 203 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
#line 1174 "fuzzy-search-popover.c"
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
#line 203 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		c_collection = _tmp7_;
#line 203 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
#line 1182 "fuzzy-search-popover.c"
			GtkWidget* c = NULL;
#line 203 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			c = (GtkWidget*) c_it->data;
#line 1186 "fuzzy-search-popover.c"
			{
				GtkListBox* _tmp8_;
				GtkWidget* _tmp9_;
#line 204 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp8_ = self->priv->search_result_container;
#line 204 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp9_ = c;
#line 204 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				gtk_container_remove ((GtkContainer*) _tmp8_, _tmp9_);
#line 1196 "fuzzy-search-popover.c"
			}
		}
#line 203 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		(c_collection == NULL) ? NULL : (c_collection = (g_list_free (c_collection), NULL));
#line 1201 "fuzzy-search-popover.c"
	}
#line 207 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp10_ = self->priv->items;
#line 207 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp10_);
#line 1207 "fuzzy-search-popover.c"
	{
		GeeArrayList* _result_list = NULL;
		GeeArrayList* _tmp11_;
		gint _result_size = 0;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _result_index = 0;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp11_ = results;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_result_list = _tmp11_;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp12_ = _result_list;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp14_ = _tmp13_;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_result_size = _tmp14_;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_result_index = -1;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		while (TRUE) {
#line 1232 "fuzzy-search-popover.c"
			gint _tmp15_;
			gint _tmp16_;
			SearchResult* _result_ = NULL;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			FileItem* file_item = NULL;
			SearchResult* _tmp19_;
			ScratchServicesFuzzySearchIndexer* _tmp20_;
			GeeHashMap* _tmp21_;
			GeeHashMap* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			FileItem* _tmp25_;
			FileItem* _tmp26_;
			GtkListBox* _tmp29_;
			FileItem* _tmp30_;
			GeeArrayList* _tmp31_;
			FileItem* _tmp32_;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_result_index = _result_index + 1;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp15_ = _result_index;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp16_ = _result_size;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			if (!(_tmp15_ < _tmp16_)) {
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				break;
#line 1261 "fuzzy-search-popover.c"
			}
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp17_ = _result_list;
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _result_index);
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_result_ = (SearchResult*) _tmp18_;
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp19_ = _result_;
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp20_ = self->priv->indexer;
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp21_ = scratch_services_fuzzy_search_indexer_get_project_paths (_tmp20_);
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp22_ = _tmp21_;
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp23_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp22_);
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp24_ = _tmp23_;
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp25_ = file_item_new (_tmp19_, _tmp24_ > 1);
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			g_object_ref_sink (_tmp25_);
#line 210 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			file_item = _tmp25_;
#line 211 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp26_ = file_item;
#line 211 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			gtk_widget_set_can_focus ((GtkWidget*) _tmp26_, FALSE);
#line 213 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			if (first) {
#line 1293 "fuzzy-search-popover.c"
				FileItem* _tmp27_;
				GtkStyleContext* _tmp28_;
#line 214 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				first = FALSE;
#line 215 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp27_ = file_item;
#line 215 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
#line 215 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				gtk_style_context_add_class (_tmp28_, "preselect-fuzzy");
#line 216 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				self->priv->preselected_index = 0;
#line 1306 "fuzzy-search-popover.c"
			}
#line 219 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp29_ = self->priv->search_result_container;
#line 219 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp30_ = file_item;
#line 219 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
#line 220 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp31_ = self->priv->items;
#line 220 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp32_ = file_item;
#line 220 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_g_object_unref0 (file_item);
#line 209 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_search_result_unref0 (_result_);
#line 1324 "fuzzy-search-popover.c"
		}
	}
#line 223 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp33_ = self->priv->scrolled;
#line 223 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_hide ((GtkWidget*) _tmp33_);
#line 224 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp34_ = self->priv->scrolled;
#line 224 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp34_);
#line 227 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp35_ = self->priv->scrolled;
#line 227 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp36_ = gtk_scrolled_window_get_vadjustment (_tmp35_);
#line 227 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp37_ = _tmp36_;
#line 227 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_adjustment_set_value (_tmp37_, (gdouble) 0);
#line 188 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (results);
#line 1345 "fuzzy-search-popover.c"
}

static void
___lambda24__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	__lambda24_ (self, source_object, res);
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	block11_data_unref (self);
#line 1357 "fuzzy-search-popover.c"
}

static gboolean
___lambda23_ (Block10Data* _data10_)
{
	ScratchFuzzySearchPopover* self;
	Block11Data* _data11_;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GCancellable* _tmp8_;
	GeeLinkedList* _tmp9_;
	GCancellable* _tmp10_;
	gint dir_length = 0;
	gchar* term = NULL;
	GtkSearchEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** parts = NULL;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint parts_length1;
	gint _parts_size_;
	gchar** rev_parts = NULL;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gint rev_parts_length1;
	gint _rev_parts_size_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	ScratchServicesFuzzyFinder* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GCancellable* _tmp33_;
	gboolean result;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self = _data10_->self;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_data11_->_ref_count_ = 1;
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_data11_->_data10_ = block10_data_ref (_data10_);
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = _data10_->previous_text;
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = strlen (_tmp1_);
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = _tmp2_;
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp3_ == 0) {
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp0_ = TRUE;
#line 1420 "fuzzy-search-popover.c"
	} else {
		const gchar* _tmp4_;
		GtkSearchEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp4_ = _data10_->previous_text;
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp5_ = self->priv->search_term_entry;
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp6_ = gtk_entry_get_text ((GtkEntry*) _tmp5_);
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp7_ = _tmp6_;
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp7_) != 0;
#line 1436 "fuzzy-search-popover.c"
	}
#line 171 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp0_) {
#line 172 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		result = G_SOURCE_REMOVE;
#line 172 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		block11_data_unref (_data11_);
#line 172 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data11_ = NULL;
#line 172 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		return result;
#line 1448 "fuzzy-search-popover.c"
	}
#line 175 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp8_ = g_cancellable_new ();
#line 175 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_data11_->next_cancellable = _tmp8_;
#line 176 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp9_ = self->priv->cancellables;
#line 176 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp10_ = _data11_->next_cancellable;
#line 176 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp10_);
#line 178 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	dir_length = 0;
#line 178 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp11_ = self->priv->search_term_entry;
#line 178 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp12_ = gtk_entry_get_text ((GtkEntry*) _tmp11_);
#line 178 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp13_ = _tmp12_;
#line 178 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 178 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	term = _tmp14_;
#line 179 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp15_ = term;
#line 179 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, G_DIR_SEPARATOR_S, 0);
#line 179 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	parts = _tmp17_;
#line 179 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	parts_length1 = _vala_array_length (_tmp16_);
#line 179 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_parts_size_ = parts_length1;
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp18_ = term;
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp19_ = g_utf8_strreverse (_tmp18_, (gssize) -1);
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp20_ = _tmp19_;
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp22_ = _tmp21_ = g_strsplit (_tmp20_, G_DIR_SEPARATOR_S, 2);
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp23_ = _tmp22_;
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp23__length1 = _vala_array_length (_tmp21_);
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_free0 (_tmp20_);
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	rev_parts = _tmp23_;
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	rev_parts_length1 = _tmp23__length1;
#line 180 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_rev_parts_size_ = rev_parts_length1;
#line 181 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp24_ = rev_parts;
#line 181 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp24__length1 = rev_parts_length1;
#line 181 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp24__length1 == 2) {
#line 1508 "fuzzy-search-popover.c"
		gchar** _tmp25_;
		gint _tmp25__length1;
		const gchar* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 182 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp25_ = rev_parts;
#line 182 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp25__length1 = rev_parts_length1;
#line 182 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp26_ = _tmp25_[0];
#line 182 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp27_ = strlen (_tmp26_);
#line 182 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp28_ = _tmp27_;
#line 182 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		dir_length = _tmp28_ + 1;
#line 1526 "fuzzy-search-popover.c"
	}
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp29_ = self->priv->fuzzy_finder;
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp30_ = term;
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp31_ = scratch_fuzzy_search_popover_get_current_project (self);
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp32_ = _tmp31_;
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp33_ = _data11_->next_cancellable;
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	scratch_services_fuzzy_finder_fuzzy_find_async (_tmp29_, _tmp30_, (guint) dir_length, _tmp32_, _tmp33_, ___lambda24__gasync_ready_callback, block11_data_ref (_data11_));
#line 185 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_free0 (_tmp32_);
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	result = G_SOURCE_REMOVE;
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	rev_parts = (_vala_array_free (rev_parts, rev_parts_length1, (GDestroyNotify) g_free), NULL);
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_free0 (term);
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	block11_data_unref (_data11_);
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_data11_ = NULL;
#line 230 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 1556 "fuzzy-search-popover.c"
}

static gboolean
____lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda23_ (self);
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return result;
#line 1566 "fuzzy-search-popover.c"
}

static void
_scratch_fuzzy_search_popover___lambda22_ (ScratchFuzzySearchPopover* self,
                                           GtkEditable* e)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 160 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_return_if_fail (e != NULL);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_ = self->priv->search_term_entry;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = _tmp1_;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = strlen (_tmp2_);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp4_ = _tmp3_;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	if (_tmp4_ >= 1) {
#line 1592 "fuzzy-search-popover.c"
		Block10Data* _data10_;
		GtkSearchEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GeeLinkedList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data10_ = g_slice_new0 (Block10Data);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data10_->_ref_count_ = 1;
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data10_->self = g_object_ref (self);
#line 162 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp5_ = self->priv->search_term_entry;
#line 162 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp6_ = gtk_entry_get_text ((GtkEntry*) _tmp5_);
#line 162 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp7_ = _tmp6_;
#line 162 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 162 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data10_->previous_text = _tmp8_;
#line 163 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp9_ = self->priv->cancellables;
#line 163 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 163 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp11_ = _tmp10_;
#line 163 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		if (_tmp11_ > 0) {
#line 1625 "fuzzy-search-popover.c"
			GCancellable* last_cancellable = NULL;
			GeeLinkedList* _tmp12_;
			gpointer _tmp13_;
			GCancellable* _tmp14_;
#line 164 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp12_ = self->priv->cancellables;
#line 164 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp13_ = gee_linked_list_last (_tmp12_);
#line 164 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			last_cancellable = (GCancellable*) _tmp13_;
#line 165 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_tmp14_ = last_cancellable;
#line 165 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			g_cancellable_cancel (_tmp14_);
#line 163 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			_g_object_unref0 (last_cancellable);
#line 1642 "fuzzy-search-popover.c"
		}
#line 168 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda23__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		block10_data_unref (_data10_);
#line 161 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_data10_ = NULL;
#line 1650 "fuzzy-search-popover.c"
	} else {
		GtkListBox* _tmp15_;
		GList* _tmp16_;
		GeeArrayList* _tmp19_;
		GtkScrolledWindow* _tmp20_;
#line 233 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp15_ = self->priv->search_result_container;
#line 233 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp16_ = gtk_container_get_children ((GtkContainer*) _tmp15_);
#line 1660 "fuzzy-search-popover.c"
		{
			GList* c_collection = NULL;
			GList* c_it = NULL;
#line 233 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			c_collection = _tmp16_;
#line 233 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
#line 1668 "fuzzy-search-popover.c"
				GtkWidget* c = NULL;
#line 233 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
				c = (GtkWidget*) c_it->data;
#line 1672 "fuzzy-search-popover.c"
				{
					GtkListBox* _tmp17_;
					GtkWidget* _tmp18_;
#line 234 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					_tmp17_ = self->priv->search_result_container;
#line 234 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					_tmp18_ = c;
#line 234 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
					gtk_container_remove ((GtkContainer*) _tmp17_, _tmp18_);
#line 1682 "fuzzy-search-popover.c"
				}
			}
#line 233 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
			(c_collection == NULL) ? NULL : (c_collection = (g_list_free (c_collection), NULL));
#line 1687 "fuzzy-search-popover.c"
		}
#line 237 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp19_ = self->priv->items;
#line 237 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp19_);
#line 238 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		_tmp20_ = self->priv->scrolled;
#line 238 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		gtk_widget_hide ((GtkWidget*) _tmp20_);
#line 1697 "fuzzy-search-popover.c"
	}
}

static void
__scratch_fuzzy_search_popover___lambda22__gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self)
{
#line 160 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_scratch_fuzzy_search_popover___lambda22_ ((ScratchFuzzySearchPopover*) self, _sender);
#line 1707 "fuzzy-search-popover.c"
}

static GObject *
scratch_fuzzy_search_popover_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchFuzzySearchPopover * self;
	GdkRectangle _tmp0_ = {0};
	GtkStyleContext* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkSearchEntry* _tmp7_;
	GtkSearchEntry* _tmp8_;
	GtkListBox* _tmp9_ = NULL;
	GtkListBox* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkListBox* _tmp12_;
	GtkSearchEntry* _tmp13_;
	GtkEventControllerKey* _tmp14_;
	GtkEventControllerKey* _tmp15_;
	GtkSearchEntry* _tmp16_;
	GtkSearchEntry* _tmp17_;
	GtkBox* entry_layout = NULL;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkLabel* _tmp21_;
	GtkBox* _tmp22_;
	GtkSearchEntry* _tmp23_;
	GtkSearchEntry* _tmp24_;
	GtkScrolledWindow* _tmp25_ = NULL;
	GtkScrolledWindow* _tmp26_;
	GtkListBox* _tmp27_;
	GtkBox* box = NULL;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	GtkBox* _tmp31_;
	GtkScrolledWindow* _tmp32_;
	GtkBox* _tmp33_;
	GtkScrolledWindow* _tmp34_;
	GtkBox* _tmp35_;
#line 83 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	parent_class = G_OBJECT_CLASS (scratch_fuzzy_search_popover_parent_class);
#line 83 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 83 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, ScratchFuzzySearchPopover);
#line 84 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_.x = 0;
#line 84 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_.y = 32;
#line 84 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_.width = 1;
#line 84 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp0_.height = 1;
#line 84 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_set ((GtkPopover*) self, "pointing-to", &_tmp0_, NULL);
#line 85 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 85 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_style_context_add_class (_tmp1_, "fuzzy-popover");
#line 87 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Find project files"));
#line 87 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_ref_sink (_tmp2_);
#line 87 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->title_label);
#line 87 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->title_label = _tmp2_;
#line 88 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp3_ = self->priv->title_label;
#line 88 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 89 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp4_ = self->priv->title_label;
#line 89 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 89 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_style_context_add_class (_tmp5_, "h4");
#line 91 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp6_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 91 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_ref_sink (_tmp6_);
#line 91 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->search_term_entry);
#line 91 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->search_term_entry = _tmp6_;
#line 92 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp7_ = self->priv->search_term_entry;
#line 92 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_FILL);
#line 93 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp8_ = self->priv->search_term_entry;
#line 93 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp9_ = (GtkListBox*) gtk_list_box_new ();
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_list_box_set_selection_mode (_tmp9_, GTK_SELECTION_NONE);
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_list_box_set_activate_on_single_click (_tmp9_, TRUE);
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp9_, FALSE);
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_ref_sink (_tmp9_);
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->search_result_container);
#line 95 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->search_result_container = _tmp9_;
#line 101 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp10_ = self->priv->search_result_container;
#line 101 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 101 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_style_context_add_class (_tmp11_, "fuzzy-list");
#line 103 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp12_ = self->priv->search_result_container;
#line 103 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_signal_connect_object (_tmp12_, "row-activated", (GCallback) __scratch_fuzzy_search_popover___lambda19__gtk_list_box_row_activated, self, 0);
#line 112 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp13_ = self->priv->search_term_entry;
#line 112 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp14_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) _tmp13_);
#line 112 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->search_term_entry_key_controller);
#line 112 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->search_term_entry_key_controller = _tmp14_;
#line 113 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp15_ = self->priv->search_term_entry_key_controller;
#line 113 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_signal_connect_object (_tmp15_, "key-pressed", (GCallback) __scratch_fuzzy_search_popover___lambda20__gtk_event_controller_key_key_pressed, self, 0);
#line 154 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp16_ = self->priv->search_term_entry;
#line 154 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_signal_connect_object ((GtkEntry*) _tmp16_, "activate", (GCallback) __scratch_fuzzy_search_popover___lambda21__gtk_entry_activate, self, 0);
#line 160 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp17_ = self->priv->search_term_entry;
#line 160 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_signal_connect_object ((GtkEditable*) _tmp17_, "changed", (GCallback) __scratch_fuzzy_search_popover___lambda22__gtk_editable_changed, self, 0);
#line 242 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp18_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 242 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_ref_sink (_tmp18_);
#line 242 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	entry_layout = _tmp18_;
#line 243 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp19_ = entry_layout;
#line 243 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
#line 245 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp20_ = entry_layout;
#line 245 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp21_ = self->priv->title_label;
#line 245 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 246 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp22_ = entry_layout;
#line 246 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp23_ = self->priv->search_term_entry;
#line 246 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 247 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp24_ = self->priv->search_term_entry;
#line 247 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_START);
#line 249 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp25_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 249 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp25_, TRUE);
#line 249 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
#line 249 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_ref_sink (_tmp25_);
#line 249 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->scrolled);
#line 249 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv->scrolled = _tmp25_;
#line 254 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp26_ = self->priv->scrolled;
#line 254 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp27_ = self->priv->search_result_container;
#line 254 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 256 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp28_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 256 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_ref_sink (_tmp28_);
#line 256 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	box = _tmp28_;
#line 257 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp29_ = box;
#line 257 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp30_ = entry_layout;
#line 257 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_box_pack_start (_tmp29_, (GtkWidget*) _tmp30_, FALSE, FALSE, (guint) 0);
#line 258 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp31_ = box;
#line 258 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp32_ = self->priv->scrolled;
#line 258 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_box_pack_end (_tmp31_, (GtkWidget*) _tmp32_, TRUE, TRUE, (guint) 0);
#line 259 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp33_ = box;
#line 259 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp33_);
#line 261 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp34_ = self->priv->scrolled;
#line 261 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_widget_hide ((GtkWidget*) _tmp34_);
#line 262 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_tmp35_ = box;
#line 262 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp35_);
#line 83 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (box);
#line 83 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (entry_layout);
#line 83 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	return obj;
#line 1934 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_class_init (ScratchFuzzySearchPopoverClass * klass,
                                         gpointer klass_data)
{
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	scratch_fuzzy_search_popover_parent_class = g_type_class_peek_parent (klass);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_type_class_adjust_private_offset (klass, &ScratchFuzzySearchPopover_private_offset);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_fuzzy_search_popover_get_property;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_fuzzy_search_popover_set_property;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	G_OBJECT_CLASS (klass)->constructor = scratch_fuzzy_search_popover_constructor;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_fuzzy_search_popover_finalize;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FUZZY_SEARCH_POPOVER_CURRENT_WINDOW_PROPERTY, scratch_fuzzy_search_popover_properties[SCRATCH_FUZZY_SEARCH_POPOVER_CURRENT_WINDOW_PROPERTY] = g_param_spec_object ("current-window", "current-window", "current-window", SCRATCH_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FUZZY_SEARCH_POPOVER_SIDEBAR_IS_VISIBLE_PROPERTY, scratch_fuzzy_search_popover_properties[SCRATCH_FUZZY_SEARCH_POPOVER_SIDEBAR_IS_VISIBLE_PROPERTY] = g_param_spec_boolean ("sidebar-is-visible", "sidebar-is-visible", "sidebar-is-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	scratch_fuzzy_search_popover_signals[SCRATCH_FUZZY_SEARCH_POPOVER_OPEN_FILE_SIGNAL] = g_signal_new ("open-file", SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	scratch_fuzzy_search_popover_signals[SCRATCH_FUZZY_SEARCH_POPOVER_CLOSE_SEARCH_SIGNAL] = g_signal_new ("close-search", SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1961 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_instance_init (ScratchFuzzySearchPopover * self,
                                            gpointer klass)
{
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self->priv = scratch_fuzzy_search_popover_get_instance_private (self);
#line 1970 "fuzzy-search-popover.c"
}

static void
scratch_fuzzy_search_popover_finalize (GObject * obj)
{
	ScratchFuzzySearchPopover * self;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, ScratchFuzzySearchPopover);
#line 10 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->search_term_entry);
#line 11 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_scratch_services_fuzzy_finder_unref0 (self->priv->fuzzy_finder);
#line 12 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->search_result_container);
#line 14 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->scrolled);
#line 15 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->items);
#line 16 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->indexer);
#line 19 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->cancellables);
#line 20 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->search_term_entry_key_controller);
#line 21 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->title_label);
#line 22 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	_g_object_unref0 (self->priv->_current_window);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	G_OBJECT_CLASS (scratch_fuzzy_search_popover_parent_class)->finalize (obj);
#line 2001 "fuzzy-search-popover.c"
}

GType
scratch_fuzzy_search_popover_get_type (void)
{
	return scratch_fuzzy_search_popover_type_id;
}

GType
scratch_fuzzy_search_popover_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchFuzzySearchPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_fuzzy_search_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchFuzzySearchPopover), 0, (GInstanceInitFunc) scratch_fuzzy_search_popover_instance_init, NULL };
	scratch_fuzzy_search_popover_type_id = g_type_module_register_type (module, gtk_popover_get_type (), "ScratchFuzzySearchPopover", &g_define_type_info, 0);
	ScratchFuzzySearchPopover_private_offset = sizeof (ScratchFuzzySearchPopoverPrivate);
	return scratch_fuzzy_search_popover_type_id;
}

static void
_vala_scratch_fuzzy_search_popover_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	ScratchFuzzySearchPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, ScratchFuzzySearchPopover);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	switch (property_id) {
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case SCRATCH_FUZZY_SEARCH_POPOVER_CURRENT_WINDOW_PROPERTY:
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_value_set_object (value, scratch_fuzzy_search_popover_get_current_window (self));
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		break;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case SCRATCH_FUZZY_SEARCH_POPOVER_SIDEBAR_IS_VISIBLE_PROPERTY:
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		g_value_set_boolean (value, scratch_fuzzy_search_popover_get_sidebar_is_visible (self));
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		break;
#line 2041 "fuzzy-search-popover.c"
		default:
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		break;
#line 2047 "fuzzy-search-popover.c"
	}
}

static void
_vala_scratch_fuzzy_search_popover_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	ScratchFuzzySearchPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_TYPE_FUZZY_SEARCH_POPOVER, ScratchFuzzySearchPopover);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
	switch (property_id) {
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case SCRATCH_FUZZY_SEARCH_POPOVER_CURRENT_WINDOW_PROPERTY:
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		scratch_fuzzy_search_popover_set_current_window (self, g_value_get_object (value));
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		break;
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		case SCRATCH_FUZZY_SEARCH_POPOVER_SIDEBAR_IS_VISIBLE_PROPERTY:
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		scratch_fuzzy_search_popover_set_sidebar_is_visible (self, g_value_get_boolean (value));
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		break;
#line 2073 "fuzzy-search-popover.c"
		default:
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../plugins/fuzzy-search/fuzzy-search-popover.vala"
		break;
#line 2079 "fuzzy-search-popover.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

